import java.awt.*;
import java.applet.*;
import java.awt.event.*;

/** 
 * Assignment 5 for 415.101FC 2000
 *
 * @author Vincent Wing Hei, Ho
 * @version 2000.3.28
 */
 
public class A5 extends Applet implements ActionListener, MouseListener {
    /** Textfield for displaying the mode currently in */
    private TextField modeDisplay;
    /** Storing which mode is now in */
    private String mode = "MOVING";
    /** Store which corner has been clicked */
    private String whichCorner = "none";
    /** Storing whether first or second click */
    private boolean firstClick = true;
    /** X-coordinate of the four corners */
    private int aX, bX, cX, dX;
    /** Y-coordinate of the four corners */
    private int aY, bY, cY, dY;
    /** X, Y coordinates of the first click */
    private int mouseX1, mouseY1; 
    /** size of boxes at corners */
    private final int BOX_SIZE = 10;

    public void init() {
        setLayout(null);

        // use these to position the Button
        final int BUTTON_X = 10;
        final int BUTTON_Y = 10;
        final int BUTTON_WIDTH = 90;
        final int BUTTON_HEIGHT = 20;
    
        Button selectMode;
        selectMode = new Button("Move/Reshape");
        selectMode.setBounds(BUTTON_X, BUTTON_Y, BUTTON_WIDTH, BUTTON_HEIGHT);
        selectMode.addActionListener(this);
        add(selectMode);

        // use these to position the TextField
        final int TEXT_X = 105;
        final int TEXT_Y = 10;
        final int TEXT_WIDTH = 185;
        final int TEXT_HEIGHT = 20;
    
        modeDisplay = new TextField();
        modeDisplay.setBounds(TEXT_X, TEXT_Y, TEXT_WIDTH, TEXT_HEIGHT);
        add(modeDisplay);

        addMouseListener(this);

        // initialise the variables
        aX = 75;
        bX = 225;
        cX = 225;
        dX = 75;
        aY = 75;
        bY = 75;
        cY = 225;
        dY = 225;
    }

    /** 
     Changes mode when button is pressed
    */
    public void actionPerformed(ActionEvent e) {
        firstClick = true;                       //reset to first click after mode change
        whichCorner = "none";
        if (mode.equals("MOVING"))
            mode = "RESHAPING";
       else
            mode = "MOVING";
        repaint();
    }


    /** 
      Handle mouse inputs
    */    
    public void mousePressed(MouseEvent e) {
        if (firstClick) {                        // First Click
            mouseX1 = e.getX();
            mouseY1 = e.getY();
            if (((mouseX1 > aX - (int)(BOX_SIZE / 2)) && (mouseX1 < (aX + (int)(BOX_SIZE / 2))))
                        && ((mouseY1 > aY - (int)(BOX_SIZE / 2)) && (mouseY1 < (aY + (int)(BOX_SIZE / 2)))))
                whichCorner = "a";  
            else if (((mouseX1 > bX - (int)(BOX_SIZE / 2)) && (mouseX1 < (bX + (int)(BOX_SIZE / 2))))
                        && ((mouseY1 > bY - (int)(BOX_SIZE / 2)) && (mouseY1 < (bY + (int)(BOX_SIZE / 2)))))
                whichCorner = "b";
            else if (((mouseX1 > cX - (int)(BOX_SIZE / 2)) && (mouseX1 < (cX + (int)(BOX_SIZE / 2))))
                        && ((mouseY1 > cY - (int)(BOX_SIZE / 2)) && (mouseY1 < (cY + (int)(BOX_SIZE / 2)))))
                whichCorner = "c";
            else if (((mouseX1 > dX - (int)(BOX_SIZE / 2)) && (mouseX1 < (dX + (int)(BOX_SIZE / 2))))
                        && ((mouseY1 > dY - (int)(BOX_SIZE / 2)) && (mouseY1 < (dY + (int)(BOX_SIZE / 2)))))
                whichCorner = "d";
            repaint();
        }
        else {                                   // Second Click
            if (whichCorner.equals("a") || whichCorner.equals("b") || whichCorner.equals("c") || whichCorner.equals("d")) {
                int mouseX2, mouseY2;            // X, Y coordinates of the second click
                mouseX2 = e.getX();
                mouseY2 = e.getY();
                if (mode.equals("MOVING")) {     // MOVING mode, Second click
                    aX += (mouseX2 - mouseX1);
                    bX += (mouseX2 - mouseX1);
                    cX += (mouseX2 - mouseX1);
                    dX += (mouseX2 - mouseX1);
                    aY += (mouseY2 - mouseY1);
                    bY += (mouseY2 - mouseY1);
                    cY += (mouseY2 - mouseY1);
                    dY += (mouseY2 - mouseY1);
                }
                else {                           // RESHAPING mode, second click
                    if (whichCorner.equals("a")) {
                        aX += (mouseX2 - mouseX1);
                        aY += (mouseY2 - mouseY1);
                    }
                    else if (whichCorner.equals("b")) {
                        bX += (mouseX2 - mouseX1);
                        bY += (mouseY2 - mouseY1);
                    }
                    else if (whichCorner.equals("c")) {
                        cX += (mouseX2 - mouseX1);
                        cY += (mouseY2 - mouseY1);
                    }
                    else if (whichCorner.equals("d")) {
                        dX += (mouseX2 - mouseX1);
                        dY += (mouseY2 - mouseY1);
                    }
                }                             
            }
        repaint();
        }
    }
    
    /**
      Handles graphical outputs
    */  
    public void paint(Graphics g) {
        if (firstClick) {                        // First Click
            g.setColor(Color.red);               // highlight selected corner box
            if (whichCorner.equals("a")) {
                g.fillRect(aX - (int)(BOX_SIZE / 2), aY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
                firstClick = false;
            }
            else if (whichCorner.equals("b")) {
                g.fillRect(bX - (int)(BOX_SIZE / 2), bY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
                firstClick = false;
            }
            else if (whichCorner.equals("c")) {
                g.fillRect(cX - (int)(BOX_SIZE / 2), cY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
                firstClick = false;
            }
            else if (whichCorner.equals("d")) {
                g.fillRect(dX - (int)(BOX_SIZE / 2), dY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
                firstClick = false;
            }
        }
        else {                                   // Second Click
            g.setColor(Color.white);             // undo highlight of corner box
            g.fillRect(aX - (int)(BOX_SIZE / 2), aY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
            g.fillRect(bX - (int)(BOX_SIZE / 2), bY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
            g.fillRect(cX - (int)(BOX_SIZE / 2), cY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
            g.fillRect(dX - (int)(BOX_SIZE / 2), dY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
            firstClick = true;
            whichCorner = "none";
        }       
        modeDisplay.setText("Current Mode: " + mode);
        g.setColor(Color.black);
        g.drawLine(aX, aY, bX, bY);
        g.drawLine(bX, bY, cX, cY);
        g.drawLine(cX, cY, dX, dY);
        g.drawLine(dX, dY, aX, aY);
        g.drawRect(aX - (int)(BOX_SIZE / 2), aY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
        g.drawRect(bX - (int)(BOX_SIZE / 2), bY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
        g.drawRect(cX - (int)(BOX_SIZE / 2), cY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
        g.drawRect(dX - (int)(BOX_SIZE / 2), dY - (int)(BOX_SIZE / 2), BOX_SIZE, BOX_SIZE);
    }
    
    /**
      Unused methods but needed to compile
    */
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
}